unit uFormulario;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.AppEvnts, Vcl.StdCtrls;

type
  TFormCapturaExcecoes = class(TForm)
    ApplicationEvents: TApplicationEvents;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    Bevel: TBevel;
    Memo: TMemo;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure ApplicationEventsException(Sender: TObject; E: Exception);
    procedure FormShow(Sender: TObject);
  end;

var
  FormCapturaExcecoes: TFormCapturaExcecoes;

implementation

uses
  System.Contnrs, uCapturaExcecoes, DBClient;

{$R *.dfm}

procedure TFormCapturaExcecoes.ApplicationEventsException(Sender: TObject; E: Exception);
var
  CapturaExcecoes: TCapturaExcecoes;
begin
  // Cria a classe de captura de excees
  CapturaExcecoes := TCapturaExcecoes.Create;
  try
    // Invoca o mtodo de captura, informando os parmetros
    CapturaExcecoes.CapturarExcecao(Sender, E);

    // Carrega novamente o arquivo de log no Memo
    Memo.Lines.LoadFromFile(GetCurrentDir + '\LogExcecoes.txt');

    // Navega para o final do Memo para mostrar a exceo mais recente
    SendMessage(Memo.Handle, EM_LINESCROLL, 0,Memo.Lines.Count);
  finally
    CapturaExcecoes.Free;
  end;
end;

procedure TFormCapturaExcecoes.Button1Click(Sender: TObject);
begin
  // EConvertError
  StrToInt('A');
end;

procedure TFormCapturaExcecoes.Button2Click(Sender: TObject);
var
  N1: integer;
  N2: integer;
  Resultado: integer;
begin
  // EDivByZero
  N1 := 10;
  N2 := 0;
  Resultado := N1 div N2;
  ShowMessage(IntToStr(Resultado));
end;

procedure TFormCapturaExcecoes.Button3Click(Sender: TObject);
var
  Lista: TObjectList;
  Objeto: TObject;
begin
  // EListError
  Lista := TObjectList.Create;
  try
    Objeto := Lista.Items[1];
    ShowMessage(Objeto.ClassName);
  finally
    Lista.Free;
  end;
end;

procedure TFormCapturaExcecoes.Button4Click(Sender: TObject);
begin
  // EFOpenError
  Memo.Lines.LoadFromFile('C:\ArquivoInexistente.txt');
end;

procedure TFormCapturaExcecoes.Button5Click(Sender: TObject);
var
  ClientDataSet: TClientDataSet;
begin
  // EDatabaseError
  ClientDataSet := TClientDataSet.Create(nil);
  try
    ShowMessage(ClientDataSet.FieldByName('Campo').AsString);
  finally
    ClientDataSet.Free;
  end;
end;

procedure TFormCapturaExcecoes.FormShow(Sender: TObject);
begin
  // Carrega novamente o arquivo de log no Memo
  if FileExists(GetCurrentDir + '\LogExcecoes.txt') then
    Memo.Lines.LoadFromFile(GetCurrentDir + '\LogExcecoes.txt');
end;

end.
